#include <stdio.h>
#include <stdlib.h>

#define LINHAS    3
#define COLUNAS   2

/* Obtem do usuario matriz linhasXcolunas. Se nao for possivel 
 * formar a matriz, retorna ponteiro nulo.
 * Matriz  alocada com CALLOC.
 */
double *obtemMatriz (int linhas, int colunas)
{
  int i, k;
  double *matriz;

  if (matriz = (double *) calloc (linhas*colunas, sizeof(double)))
    for (i = 0; matriz && i < linhas; i++) {
	for (k = 0; k < colunas ; k++) {
	  printf("\t\tElemento (%d,%d): ", i+1, k+1);
	  scanf("%lf", matriz + (i*colunas) + k);
	}
    }

  return (matriz);
}

/* Soma duas matrizes mat_1 e mat_2. O resultado eh colocado em mat_2 */
void somaMatriz (double *mat_1, double *mat_2, 
		 int linhas, int colunas)
{
  int i, k;
  for (i=0; i < linhas; i++) {
    for (k=0; k < colunas; k++)
      *(mat_2 + (i*colunas) + k) += *(mat_1 + (i*colunas) + k);
  }
}

/* Imprime matriz na saida padrao. */
void imprimeMatriz (double **matriz, int linhas, int colunas)
{
  int i, k;
  for (i=0; i < linhas; i++) {
    for (k=0; k < colunas; k++)
      printf("%5.2lf\t", matriz[i][k]);
    printf("\n");
  }
}

/* Programa Principal */
main (int argc, char *argv[]) 
{

  double *matriz,
         *soma;
  int i,k,
      linhas = LINHAS, 
      colunas = COLUNAS;

  if (argc > 3)
    printf("\nForma de uso: %s [linhas colunas]\n\n", argv[0]);
  else {
    if (argc == 3) {
      linhas = atoi (argv[1]);
      colunas = atoi (argv[2]);
    }
    else if (argc == 2)
      linhas = atoi (argv[1]);
    
    printf("Forneca 2 matrizes %d x %d:\n",linhas, colunas);
    puts("\t1a. Matriz:");
    if (matriz = obtemMatriz (linhas, colunas)) {
      puts("\n\t2a. Matriz:");
      if (soma = obtemMatriz (linhas, colunas)) {
	somaMatriz(matriz, soma, linhas, colunas);
	imprimeMatriz((double **) soma, linhas, colunas);
      }
    }

    if (! matriz || ! soma)
      printf ("Erro na alocaao de espao para matrizes\n");
  }
}
